var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import createInstance from './createInstance';
import makeActionCreator from './makeActionCreator';

/**
 * Create Redux actions from Class or object
 * @param {Function|Object} Actions
 * @param {String} [prefix]
 * @return {Object} Action creators
 */
export default function createActions(Actions, prefix) {
  var actions = createInstance(Actions);

  return Object.keys(actions).reduce(function (result, name) {
    var _extends2;

    return _extends({}, result, (_extends2 = {}, _extends2[name] = makeActionCreator(prefix, name, actions[name]), _extends2));
  }, {});
}