'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = createActions;

var _createInstance = require('./createInstance');

var _createInstance2 = _interopRequireDefault(_createInstance);

var _makeActionCreator = require('./makeActionCreator');

var _makeActionCreator2 = _interopRequireDefault(_makeActionCreator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Create Redux actions from Class or object
 * @param {Function|Object} Actions
 * @param {String} [prefix]
 * @return {Object} Action creators
 */
function createActions(Actions, prefix) {
  var actions = (0, _createInstance2.default)(Actions);

  return Object.keys(actions).reduce(function (result, name) {
    var _extends2;

    return _extends({}, result, (_extends2 = {}, _extends2[name] = (0, _makeActionCreator2.default)(prefix, name, actions[name]), _extends2));
  }, {});
}