'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = createInstance;

var _utils = require('../utils');

function createInstance(Actions) {
  if (!(0, _utils.isFunction)(Actions)) return Actions;

  var actions = (0, _utils.getInternalMethods)(Actions);

  /* eslint-disable no-param-reassign */

  /**
   * Creates actions by their names
   * @param {...string} actionNames
   */
  Actions.prototype.generate = function generate() {
    for (var _len = arguments.length, actionNames = Array(_len), _key = 0; _key < _len; _key++) {
      actionNames[_key] = arguments[_key];
    }

    actionNames.forEach(function (actionName) {
      actions[actionName] = _utils.generateAction;
    });
  };

  /* eslint-enable no-param-reassign */

  return _extends({}, actions, new Actions());
}